/*#include <iostream>
#include <cstdlib>
#include <vector>
#include <cmath>
#include <utility>
#include <queue>
#include <algorithm>
using namespace std;

int n, m, x, y;
long long z;
vector < pair < int, pair<int,long long> > > g ; //  

int cost = 0;
vector < pair<int,int> > res;

int main(){
    cin >> n >> m;
    g.resize(m);
    for(int i = 0; i < m; i++){
        cin >> x >> y >> z;
        g[i] = make_pair(x, make_pair(y, z));
    }
sort (g.begin(), g.end());
vector<int> tree_id (n);
for (int i=0; i<n; ++i)
	tree_id[i] = i;
for (int i=0; i<m; ++i)
{
	int a = g[i].second.first,  b = g[i].second.second,  l = g[i].first;
	if (tree_id[a] != tree_id[b])
	{
		cost += l;
		res.push_back (make_pair (a, b));
		int old_id = tree_id[b],  new_id = tree_id[a];
		for (int j=0; j<n; ++j)
			if (tree_id[j] == old_id)
				tree_id[j] = new_id;
	}
}

vector<int>::iterator it;
int i= 1;
for(it = tree_id.begin(); it!= tree_id.end(); it++){
    cout << i << ": " << *it << " ";
    i++;
}

return 0;
}
*/
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <fstream>
using namespace std;
/*      */
#define MAXN 200

/*      */
#define MAXM 1000000

int n, m, x, y, z;
typedef struct {
  unsigned i, j, b;
  long long f;
} arc;

arc S[MAXM];

ofstream fout ("graph.out");
    ifstream fin ("graph.in");

int prev[MAXN + 1];

int getRoot(int i)
{ int root, savei;
  /*      */
  root = i;
  while (-1 != prev[root]) root = prev[root];
  /*    */
  while (i != root) {
    savei = i;
    i = prev[i];
    prev[savei] = root;
  }
  return root;
}

bool cmp(arc a, arc b){
    if(b.f>a.f) return true;
    else return false;
}
void kruskal(void)
{ int MST = 0;
  unsigned i, j;
  /*           */
  sort(S, S+m, cmp);

  for (i = 0; i < m; i++) {
    int r1 = getRoot(S[i].i);
    int r2 = getRoot(S[i].j);
    if (r1 != r2) {
      fout << S[i].b << endl;
      MST += S[i].f;
      prev[r2] = r1;
    }
  }
}

int main(void) {
  unsigned i;
  fin >> n >> m;
  for(int i = 0; i < m; i++){
    fin >>x >> y >> z;
    S[i].i = x; S[i].j = y; S[i].f = z; S[i].b = i+1;
  }
  for (i = 0; i < n + 1; i++) prev[i] = -1;
  kruskal();
  return 0;
}
